package com.example.switchyard.switchyard_database_binding;

import java.io.Serializable;

import javax.persistence.*;

/**
 * Entity implementation class for Entity: TestEntity
 *
 */
@Entity(name="TestEntity")
@Table(name="test")
@NamedQuery(name=TestEntity.FETCH_TEST_ENTITY_NOT_PROCESSED, query="SELECT t FROM TestEntity t WHERE t.status <> com.example.switchyard.switchyard_database_binding.TestEntityStatus.PROCESSED AND t.status <> com.example.switchyard.switchyard_database_binding.TestEntityStatus.FAILED")
public class TestEntity implements Serializable {
	private static final long serialVersionUID = 1L;

	public static final String FETCH_TEST_ENTITY_NOT_PROCESSED = "TestEntity.fetchEntityNotProcessed";
	
	@Id
	@GeneratedValue(strategy=GenerationType.IDENTITY)
	private Long id;
	
	private String payLoad;
	
	@Enumerated(EnumType.STRING)
	private TestEntityStatus status;

	public TestEntity() {
		super();
	}

	public TestEntity(Long id, String payLoad, TestEntityStatus status) {
		super();
		this.id = id;
		this.payLoad = payLoad;
		this.status = status;
	}

	public Long getId() {
		return id;
	}

	public void setId(Long id) {
		this.id = id;
	}

	public String getPayLoad() {
		return payLoad;
	}

	public void setPayLoad(String payLoad) {
		this.payLoad = payLoad;
	}

	public TestEntityStatus getStatus() {
		return status;
	}

	public void setStatus(TestEntityStatus status) {
		this.status = status;
	}

	@Override
	public String toString() {
		return "TestEntity [id=" + id + ", payLoad=" + payLoad + ", status="
				+ status + "]";
	}
	
	
}
