package com.example.switchyard.switchyard_database_binding;

import java.io.File;

import javax.ejb.EJB;

import org.jboss.arquillian.container.test.api.Deployment;
import org.jboss.arquillian.junit.Arquillian;
import org.jboss.shrinkwrap.api.ShrinkWrap;
import org.jboss.shrinkwrap.api.spec.JavaArchive;
import org.junit.Assert;
import org.junit.Test;
import org.junit.runner.RunWith;

@RunWith(Arquillian.class)
public class SwitchyardContainerTest {
	@EJB
	private TestEntityDAO testEntityDAO;
	
    @Deployment
    public static JavaArchive createTestArchive() {
    	JavaArchive archive = ShrinkWrap.create(JavaArchive.class, "switchyard-database-binding.jar");
    	
    	archive.addPackage(SwitchyardContainerTest.class.getPackage());
    	
    	archive.addAsResource(new File("src/main/resources/META-INF/"));
    	
    	return archive;
    }
        
	@Test
	public void testSuccessfulEntry() {
		testEntry("test", TestEntityStatus.PROCESSED);
	}


	@Test
	public void testFailureEntry() {
		testEntry("fail", TestEntityStatus.FAILED);
	}
	
	public void testEntry(String payLoad, TestEntityStatus expectedStatus) {
		TestEntity testEntity = new TestEntity(null, payLoad, TestEntityStatus.NEW);
		testEntity = testEntityDAO.insert(testEntity);
		
		try {
			Thread.sleep(15l * 1000l);
		} catch (InterruptedException e) {
			e.printStackTrace();
		}
		
		testEntity = testEntityDAO.get(testEntity.getId());
		
		testEntityDAO.delete(testEntity.getId());	

		Assert.assertEquals(testEntity.getStatus(), expectedStatus);
	}
}
